//Author: Alexander G. Schwing

#ifndef __GENERAL_DEFINITIONS__
#define __GENERAL_DEFINITIONS__
//#define USE_ON_WINDOWS

#ifdef USE_ON_WINDOWS
#include <windows.h>
#else
#include <sys/time.h>
#endif

class CPrecisionTimer
{
#ifdef USE_ON_WINDOWS
	LARGE_INTEGER lFreq, lStart;
#else
	timeval lStart;
#endif

public:
	CPrecisionTimer()
	{
#ifdef USE_ON_WINDOWS
		QueryPerformanceFrequency(&lFreq);
#endif
	}

	inline void Start()
	{
#ifdef USE_ON_WINDOWS
		QueryPerformanceCounter(&lStart);
#else
		gettimeofday(&lStart, 0);
#endif
	}

	inline double Stop()
	{
		// Return duration in seconds...
#ifdef USE_ON_WINDOWS
		LARGE_INTEGER lEnd;
		QueryPerformanceCounter(&lEnd);
		return (double(lEnd.QuadPart - lStart.QuadPart) / lFreq.QuadPart);
#else
		timeval lFinish;
		gettimeofday(&lFinish, 0);
		return double(lFinish.tv_sec - lStart.tv_sec) + double(lFinish.tv_usec - lStart.tv_usec)/1e6; 
#endif
	}
};

#endif